SystemOrganization addCategory: #'ChisCommit-Core'!
SystemOrganization addCategory: #'ChisCommit-Core-Tests'!

TestCase subclass: #CHCommitVisualizationTest
	instanceVariableNames: 'stamp commitVisual'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Core-Tests'!

!CHCommitVisualizationTest commentStamp: '<historical>' prior: 0!
A ROCommitVisualizationTest is a test class for testing the behavior of ROCommitVisualization!

!CHCommitVisualizationTest methodsFor: 'running' stamp: 'AlejandroInfante 1/9/2013 15:37'!
setUp

	stamp := CHTimeStamp createFromString: 'AlejandroInfante 1/8/2013 16:52'.
	commitVisual := CHCommitVisualization create: stamp.! !

!CHCommitVisualizationTest methodsFor: 'tests' stamp: 'AlejandroInfante 1/9/2013 12:09'!
testConstruction

	self assert: (commitVisual model = stamp ).
	self assert: (commitVisual numberOfInteractions = 1 ).
	self assert: (commitVisual numberOfShapes = 2).
	self assert: ((commitVisual getInteraction: ROPopup) text = 'AlejandroInfante 1/8/2013 16:52' ).
	self assert: ((commitVisual shapes at:1) isShapedAs: ROCircle).! !

TestCase subclass: #CHMethodHistoryTest
	instanceVariableNames: 'class selector methodVersions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Core-Tests'!

CHMethodHistoryTest class
	instanceVariableNames: 'class selector'!

CHMethodHistoryTest class
	instanceVariableNames: 'class selector'!

!CHMethodHistoryTest methodsFor: 'running' stamp: 'AlejandroInfante 1/9/2013 15:35'!
setUp

	class := Object subclass: #ROVersioningTestClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RoassalVersioning-Core-Tests'.
	
	selector := #myExample.
	class compile:'myExample ^ self'.
	class compile:'myExample ^ self class'.
	class compile:'myExample ^ self'.
	
	methodVersions := CHMethodHistory analyzeSelector: selector in: class.! !

!CHMethodHistoryTest methodsFor: 'running' stamp: 'AlejandroInfante 1/7/2013 18:18'!
tearDown

	class removeFromSystem.! !

!CHMethodHistoryTest methodsFor: 'tests' stamp: 'AlejandroInfante 1/9/2013 10:58'!
testAsString

	self assert: (methodVersions methodDescription = methodVersions asString).! !

!CHMethodHistoryTest methodsFor: 'tests' stamp: 'AlejandroInfante 1/9/2013 15:35'!
testCommitTimeStamps
	
	self assert:  methodVersions commitTimeStamps size = 3.
	
	methodVersions := CHMethodHistory analyzeMethod: (class compiledMethodAt: selector).
	self assert: methodVersions commitTimeStamps size = 3.
	self assert: ((methodVersions commitTimeStamps first) = (class compiledMethodAt: selector)	timeStamp).! !

!CHMethodHistoryTest methodsFor: 'tests' stamp: 'AlejandroInfante 1/9/2013 10:01'!
testMethodDescription

	self assert: (methodVersions methodDescription = selector asString).! !

TestCase subclass: #CHMethodVisualizationTest
	instanceVariableNames: 'methodHist methodVisual classMethodHist selector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Core-Tests'!

!CHMethodVisualizationTest methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/9/2013 15:35'!
extendModelClass

	selector := #commitTimeStamps.
	classMethodHist := CHMethodHistory subclass: #ROTestMethodHistory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RoassalVersioning-Core-Tests'.
	
	classMethodHist compile:'commitTimeStamps ^ #(',
		$' asString ,'ai 1/9/2013 11:00',$' asString,' ',$' asString,
		'ai 1/11/2013 11:00',$' asString,' ',$' asString ,'ai 1/10/2013 1:00',$' asString ,')'.
	^classMethodHist.! !

!CHMethodVisualizationTest methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/9/2013 15:37'!
setUp

	classMethodHist := self extendModelClass.
	methodHist := classMethodHist new analyzeMethod: (classMethodHist compiledMethodAt: selector).
	methodVisual := CHMethodVisualization create: methodHist.! !

!CHMethodVisualizationTest methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/9/2013 10:32'!
tearDown

	classMethodHist removeFromSystem.! !

!CHMethodVisualizationTest methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/9/2013 15:42'!
testConstruction

	self assert: (methodVisual model = methodHist).
	self assert: (methodVisual numberOfShapes = 2 ).
	self assert: (methodVisual numberOfInteractions = 0 ).
	self assert: ((methodVisual shapes at:1) isShapedAs: ROBox).! !

!CHMethodVisualizationTest methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/9/2013 12:14'!
testDrawCommits

	|commits|
	commits := methodHist commitTimeStamps.
	self assert:(methodVisual numberOfElements = 0).
	methodVisual drawCommits.
	self assert:(methodVisual numberOfElements = 3).! !

TestCase subclass: #CHTimeStampTest
	instanceVariableNames: 'parsedStamp method stamp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Core-Tests'!

!CHTimeStampTest commentStamp: '<historical>' prior: 0!
A ROTimeStampTest is a test class for testing the behavior of ROTimeStamp!

!CHTimeStampTest methodsFor: 'initializing' stamp: 'AlejandroInfante 1/8/2013 11:43'!
createMethod
	
	|class selector|
	class := Object subclass: #ROVersioningTestClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RoassalVersioning-Core-Tests'.
	selector := #myExample.
	class compile:'myExample ^ self'.
	class compile:'myExample ^ self class'.
	class compile:'myExample ^ self'.
	
	^ (class compiledMethodAt: selector).	! !

!CHTimeStampTest methodsFor: 'initializing' stamp: 'AlejandroInfante 1/8/2013 12:10'!
createStamp

	^ (VersionsBrowser new 
			scanVersionsOf: method
			class: method methodClass
			meta: method methodClass isMeta 
			category:  method category
			selector: method selector) list first.! !

!CHTimeStampTest methodsFor: 'running' stamp: 'AlejandroInfante 1/9/2013 15:36'!
setUp

	method := self createMethod.
	stamp := self createStamp.
	parsedStamp := CHTimeStamp createFromString: stamp.
	
! !

!CHTimeStampTest methodsFor: 'running' stamp: 'AlejandroInfante 1/8/2013 11:47'!
tearDown
	
	method methodClass removeFromSystem.! !

!CHTimeStampTest methodsFor: 'tests' stamp: 'AlejandroInfante 1/8/2013 12:32'!
testAsString

	self assert: parsedStamp asString = method timeStamp .! !

!CHTimeStampTest methodsFor: 'tests' stamp: 'AlejandroInfante 1/8/2013 11:48'!
testAuthor

	self assert: (parsedStamp author = method author ).! !

!CHTimeStampTest methodsFor: 'tests' stamp: 'AlejandroInfante 1/9/2013 09:22'!
testDate

	self assert: (parsedStamp date = method timeStamp substrings second asDate ).! !

!CHTimeStampTest methodsFor: 'tests' stamp: 'AlejandroInfante 1/8/2013 12:30'!
testEquals

	self assert:(parsedStamp = method timeStamp).! !

!CHTimeStampTest methodsFor: 'tests' stamp: 'AlejandroInfante 1/9/2013 09:23'!
testTime

	self assert: (parsedStamp time asTime = method timeStamp substrings third asTime ).! !

TestCase subclass: #CHVersionVisualizationTest
	instanceVariableNames: 'visualization'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Core-Tests'!

!CHVersionVisualizationTest commentStamp: '<historical>' prior: 0!
A ROVersionVisualizationTest is a test class for testing the behavior of ROVersionVisualization!

!CHVersionVisualizationTest methodsFor: 'running' stamp: 'AlejandroInfante 1/9/2013 15:37'!
setUp

	visualization := CHVersionVisualization new.! !

!CHVersionVisualizationTest methodsFor: 'tests' stamp: 'AlejandroInfante 1/9/2013 15:37'!
testAddMethodHistory

	| method1 method2 |
	method1 := CHMethodHistory analyzeSelector: #addMethodHistory: in: CHVersionVisualization.
	method2 := CHMethodHistory analyzeSelector:#drawCommits in:CHVersionVisualization.

	self assert: visualization methodsHistory size = 0.	
	visualization addMethodHistory: method1.
	self assert: visualization methodsHistory size = 1.
	visualization addMethodHistory: method2.
	self assert: visualization methodsHistory size = 2.! !

TestCase subclass: #CHVersionsBuilderTest
	instanceVariableNames: 'builder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Core-Tests'!

!CHVersionsBuilderTest commentStamp: '<historical>' prior: 0!
A ROVersionsBuilderTest is a test class for testing the behavior of ROVersionsBuilder!

!CHVersionsBuilderTest methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/9/2013 15:37'!
setUp

	builder := CHVersionsBuilder getInstance.! !

!CHVersionsBuilderTest methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/9/2013 15:36'!
testBuildCommitVisualization

	|stamp elem|
	stamp := CHTimeStamp createFromString: 'AlejandroInfante 1/8/2013 16:52'.
	elem := builder buildCommitVisualization: stamp.
	self assert: (elem model = stamp ).
	self assert: (elem height = 8).
	self assert: (elem width = 8).
	self assert: ((elem shapes at:1) color = Color blue  ).
	! !

!CHVersionsBuilderTest methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/9/2013 15:35'!
testBuildMethodVisualization

	|methodHistory elem|

	methodHistory := CHMethodHistory analyzeMethod: (ROCamera compiledMethodAt: #altitude).
	elem := builder buildMethodVisualization: methodHistory.
	self assert: (elem model = methodHistory).
	self assert: (elem width = 800 ).
	self assert: (elem height = 15 ).
	self assert: ((elem shapes at:1) color = Color paleGreen  ).
	! !

ROElement subclass: #CHVersionElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Core'!

!CHVersionElement commentStamp: '<historical>' prior: 0!
This is an abstract class that is the root of the visual elements displayed by Chisa, this class is a subclass from Roassals -> ROElement.!

CHVersionElement subclass: #CHCommitVisualization
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Core'!

!CHCommitVisualization commentStamp: '<historical>' prior: 0!
This object is a direct visualization of a commit, once instantiated it has everything it needs to displaying correctly.!

!CHCommitVisualization class methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/9/2013 11:58'!
defaultShape

	^ ROCircle new color: Color blue.! !

!CHCommitVisualization methodsFor: 'accessing' stamp: 'AlejandroInfante 1/9/2013 15:34'!
model: aModel

	super model: aModel.
	self @ (ROPopup text: model asString ).! !

CHVersionElement subclass: #CHMethodVisualization
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Core'!

!CHMethodVisualization commentStamp: '<historical>' prior: 0!
This object is a direct visualization of a method, once instantiated it has everything it needs to displaying correctly, also is responsible about adding the commits on the visualization.!

!CHMethodVisualization class methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/9/2013 15:42'!
defaultShape

	^ ROBox new color: Color paleGreen.! !

!CHMethodVisualization methodsFor: 'accessing' stamp: 'AlejandroInfante 1/9/2013 15:37'!
drawCommits

	|builder|
	builder := CHVersionsBuilder new.
	self addAll: (model commitTimeStamps collect: [:commit | builder buildCommitVisualization: commit]).
	ROHorizontalLineLayout on: self elements.! !

!CHVersionElement class methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/9/2013 15:46'!
create: model

	^ (self new model: model) addShape: self defaultShape.! !

!CHVersionElement class methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/9/2013 11:16'!
defaultShape

	^ self subclassResponsibility ! !

!CHVersionElement methodsFor: 'accessing' stamp: 'AlejandroInfante 1/9/2013 15:43'!
model: newModel

	super model: newModel.
	self removeInteraction: ROInteraction.
	
	^self.! !

Object subclass: #CHMethodHistory
	instanceVariableNames: 'method list changeList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Core'!

!CHMethodHistory commentStamp: '<historical>' prior: 0!
This class encapsulate the all the versions of a method.!

!CHMethodHistory class methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/8/2013 09:59'!
analyzeMethod:method

	 ^ self new analyzeMethod: method.! !

!CHMethodHistory class methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/9/2013 15:36'!
analyzeSelector: selector in: class

	^self analyzeMethod: (class compiledMethodAt: selector).! !

!CHMethodHistory methodsFor: 'initializing' stamp: 'AlejandroInfante 1/8/2013 09:59'!
analyzeMethod: newMethod

	method := newMethod.
	self initializeList.
	^self.
	! !

!CHMethodHistory methodsFor: 'converting' stamp: 'AlejandroInfante 1/9/2013 10:59'!
asString

	^ self methodDescription! !

!CHMethodHistory methodsFor: 'accessors' stamp: 'AlejandroInfante 1/8/2013 09:57'!
commitTimeStamps

	^list.! !

!CHMethodHistory methodsFor: 'initializing' stamp: 'AlejandroInfante 1/9/2013 15:36'!
initializeList

	|changeSet|
	
	changeSet  := VersionsBrowser new
			scanVersionsOf: method
			class: method methodClass
			meta: method methodClass isMeta 
			category:  method category
			selector: method selector.

	list := changeSet list collect: [:elem | 
		CHTimeStamp createFromString: elem
		].
	changeList := changeSet changeList.! !

!CHMethodHistory methodsFor: 'accessors' stamp: 'AlejandroInfante 1/9/2013 10:05'!
methodDescription

	^method selector asString.! !

Object subclass: #CHTimeStamp
	instanceVariableNames: 'author date time'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Core'!

!CHTimeStamp commentStamp: '<historical>' prior: 0!
This class encapsulate a TimeStamp generated by a commit, allowing to retrieve the information easily.!

!CHTimeStamp class methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/8/2013 12:00'!
createFromAuthor: author date: date time: time

	^ self new setAuthor: author date: date time: time.! !

!CHTimeStamp class methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/8/2013 11:59'!
createFromString: timeStamp

	| parts |
	parts := timeStamp substrings.
	^self createFromAuthor: parts first date: parts second time: parts third.! !

!CHTimeStamp methodsFor: 'comparing' stamp: 'AlejandroInfante 1/8/2013 12:32'!
= aStringOrStamp

	^ aStringOrStamp = self asString.! !

!CHTimeStamp methodsFor: 'converting' stamp: 'AlejandroInfante 1/9/2013 10:51'!
asString
	
	^ self author,' ',self date mmddyyyy,' ',self time! !

!CHTimeStamp methodsFor: 'accessors' stamp: 'AlejandroInfante 1/8/2013 12:10'!
author

	^author! !

!CHTimeStamp methodsFor: 'accessors' stamp: 'AlejandroInfante 1/8/2013 12:16'!
date

	^date.! !

!CHTimeStamp methodsFor: 'initialize-release' stamp: 'AlejandroInfante 1/9/2013 09:22'!
setAuthor: newAuthor date: newDate time: newTime
	
	author:= newAuthor.
	date:= newDate asDate.
	time:= newTime.
	
	^self

	! !

!CHTimeStamp methodsFor: 'accessors' stamp: 'AlejandroInfante 1/8/2013 12:21'!
time

	^time.! !

Object subclass: #CHVersionVisualization
	instanceVariableNames: 'view rawView elements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Core'!

!CHVersionVisualization commentStamp: '<historical>' prior: 0!
This class instantiate the Roassal view and is responsible of adding the elements!

!CHVersionVisualization methodsFor: 'action' stamp: 'AlejandroInfante 1/9/2013 15:37'!
addMethodHistory: methodHistory

	|elem builder|
	builder := CHVersionsBuilder getInstance.
	elem := builder buildMethodVisualization: methodHistory.
	elements add: elem.! !

!CHVersionVisualization methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/9/2013 15:11'!
drawCommits

	elements do: #drawCommits.! !

!CHVersionVisualization methodsFor: 'initialize-release' stamp: 'AlejandroInfante 1/8/2013 15:49'!
initialize

	rawView := ROView new.
	view := ROMondrianViewBuilder view: rawView.
	elements := OrderedCollection new.! !

!CHVersionVisualization methodsFor: 'action' stamp: 'AlejandroInfante 1/9/2013 15:28'!
launch
	
	ROVerticalLineLayout on: elements.
	rawView addAll: elements.
	"ROVerticalLineLayout new on: rawView elements."
	ROEaselMorphic new populateMenuOn: view.
	view noLayout.
	view open.! !

!CHVersionVisualization methodsFor: 'accessors' stamp: 'AlejandroInfante 1/9/2013 12:49'!
methodsHistory

	^elements! !

Object subclass: #CHVersionsBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Core'!

CHVersionsBuilder class
	instanceVariableNames: 'instance'!

!CHVersionsBuilder commentStamp: '<historical>' prior: 0!
This is a builder of CHVersionElements for an easy creation of a nice visualization.
!

CHVersionsBuilder class
	instanceVariableNames: 'instance'!

!CHVersionsBuilder class methodsFor: 'as yet unclassified' stamp: 'AlejandroInfante 1/8/2013 16:31'!
getInstance

	instance isNil ifTrue:[ instance := self new ].
	^ instance.! !

!CHVersionsBuilder methodsFor: 'builders' stamp: 'AlejandroInfante 1/9/2013 15:37'!
buildCommitVisualization: stamp

	|elem|
	elem := CHCommitVisualization create: stamp.
	elem size: 8; @RODraggable.
	^ elem.! !

!CHVersionsBuilder methodsFor: 'builders' stamp: 'AlejandroInfante 1/9/2013 15:37'!
buildMethodVisualization: methodHist

	|elem|
	elem :=CHMethodVisualization create: methodHist.
	elem width: 800; height: 15.
	^elem.! !

Object subclass: #ChisaExample
	instanceVariableNames: 'visual'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ChisCommit-Core'!

!ChisaExample methodsFor: 'initialize-release' stamp: 'AlejandroInfante 1/9/2013 15:37'!
initialize

	visual := CHVersionVisualization new.
	visual addMethodHistory: (CHMethodHistory analyzeSelector: #date in: CHTimeStamp ).
	visual addMethodHistory: (CHMethodHistory analyzeSelector: #= in: CHTimeStamp ).
	visual addMethodHistory: (CHMethodHistory analyzeSelector: #setAuthor:date:time: in: CHTimeStamp ).
	visual drawCommits.
	visual launch.! !
